/***************************************************************************
                          kbearsettingsdialog.h  -  description
                             -------------------
    begin                : tor feb 28 2002
    copyright            : (C) 2002 by Bjrn Sahlstrm
    email                : kbjorn@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef KBEARSETTINGSDIALOG_H
#define KBEARSETTINGSDIALOG_H

//////////////////////////////////////////////////////////////////////
// Qt specific include files
#include <qwidget.h>
//////////////////////////////////////////////////////////////////////
// KDE specific include files
#include <kdialogbase.h>
//////////////////////////////////////////////////////////////////////
// Application specific include files
#include "mixedsettingswidget.h"
#include "viewsettingswidget.h"
#include "windowsettingswidget.h"
#include "firewallsettingswidget.h"

/**
  *@author Bjrn Sahlstrm
  */

class KBearSettingsDialog : public KDialogBase  {
   Q_OBJECT
public: 
	/** */
	KBearSettingsDialog(QWidget *parent=0, const char *name=0);
	/** */
	~KBearSettingsDialog();
	/** */
	ViewSettingsWidget* viewSettings()const { return page1; }
	/** */
	WindowSettingsWidget* windowSettings()const { return page2; }
	/** */
	MixedSettingsWidget* mixedSettings()const { return page3; }
	/** */
	FirewallSettingsWidget* firewallSettings()const { return page4; }
protected:
	ViewSettingsWidget* page1;
	WindowSettingsWidget* page2;
	MixedSettingsWidget* page3;
	FirewallSettingsWidget* page4;
};

#endif
