/***************************************************************************
                          dirsynchtreeview.h  -  description
                             -------------------
    begin                : lr okt 19 2002
    copyright            : (C) 2002 by Bjrn Sahlstrm
    email                : kbjorn@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DIRSYNCHTREEVIEW_H
#define DIRSYNCHTREEVIEW_H

//////////////////////////////////////////////////////////////////////
// Qt specific include files
#include <qwidget.h>
#include <qpixmap.h>
#include <qcolor.h>
//////////////////////////////////////////////////////////////////////
// KDE specific include files
#include <kurl.h>
#include <kfiletreeview.h>
//////////////////////////////////////////////////////////////////////
// Application specific include files
#include "dirsynchtreebranch.h"

/**
  *@author Bjrn Sahlstrm
  */

class DirSynchTreeView : public KFileTreeView  {
   Q_OBJECT
public: 
	/** */
	DirSynchTreeView(QWidget *parent=0, const char *name=0);
	/** */
	virtual ~DirSynchTreeView();
	/** */
	virtual KFileTreeBranch* addBranch( const KURL& path, const QString& name,
										const QPixmap& pix, bool showHidden = false );
public slots:
	/** */
	virtual void setSorting( int col, bool asc );
	/** */
	void slotHeaderSizeChange( int col, int old , int n );
signals:
	/** */
	void sortingChanged( int, bool );
};

#endif
