/***************************************************************************
                          ncftpimportfilterplugin.h  -  description
                             -------------------
    begin                : tis mar 19 2002
    copyright            : (C) 2002 by Bjrn Sahlstrm
    email                : kbjorn@users.sourceforge.net
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

/***************************************************************************
 * Some code in function NcFTPImportFilterPlugin::parseLine and HexCharToNibble
 * pinched from original NcFTP source code
 * Copyright (c) 1992-2002 by Mike Gleason.
 * All rights reserved.
 ***************************************************************************/

#ifndef NcFTPImportFilterPlugin_H
#define NcFTPImportFilterPlugin_H

//////////////////////////////////////////////////////
// Qt specific includes
#include <qdir.h>
//////////////////////////////////////////////////////
// KDE specific includes
#include <kurl.h>
//////////////////////////////////////////////////////
// Application specific includes
#include "../../../base/siteimportfilterpluginiface.h"

class QDomDocument;
/**
  *@author Bjrn Sahlstrm
  */

class NcFTPImportFilterPlugin : public SiteImportFilterPluginIface  {
   Q_OBJECT
public:
	/** */
	NcFTPImportFilterPlugin(QObject *parent=0, const char *name=0, const QStringList &args = QStringList());
	/** */
	~NcFTPImportFilterPlugin();
	/**
	* This function should return a @ref QDomDocument containing the imported bookmarks.
	* The document should have the format:
	* <pre>
	*	group label="APPNAME-imports"
	*		group label="group1"
	*			site label="site1"
	*			............	
	*			/site
	*			.................
	*		/group
	*		...................
	*	/group
	*</pre>
	* @returns the @ref QDomDocument s @ref QString representation containing the imported bookmarks.
	*/
	virtual QString getDomDocument();	
	/**
	* Function should start the import
	* @param fileName is the full path to the file to import
	*/
	virtual void import( const QString& fileName );
	/**
	* This function is used by the caller to find out wether or not
	* the import waas successfull. If anything went wrong during
	* import this function should return true.
	* This stop update of databse.
	* @returns false om succes or true on error.
	*/
	virtual bool hasError() const { return m_hasError; }
private:
	enum ErrorType {
			InvalidFile = 0,
			OldFile = 1,
			NoFile = 2
	};
	void displayError( ErrorType errorType );
	int getVersion( QTextStream& fileStream );
	int getNumOfBookmarks( QTextStream& fileStream );
	int parseLine( const QString& line, QDomElement siteElement );
	QString encodePassword( const QString& password );
	int HexCharToNibble(int c);
private:
	QDomDocument m_domDocument;
	QString m_fileName;
	const int MIN_BOOKMARK_VERSION;
	bool m_hasError;
};

#endif
